    PROGRAM
    MAP
    END

    !Based on CLaMag Article: The Shortest Useful Clarion Program by Tim Phillips
    !http://www.clarionmag.com/cmag/v6/v6n04shortest.html

!Shortest    EQUATE(True)       !True  = Article Shortest Source
Shortest    EQUATE(False)       !False = Carl Barnes version
                                !        Gives up on SHort to allow for multiple FNs and make message optional

 COMPILE('***Shortest Code***',Shortest)
    CODE
    !Original Source
    SetClipboard(CLIP(LongPath(Command('1'))))
    !Message('Sent Name: ' & CLIP(LongPath(Command('1'))) & ' to the clipboard')
    !----------------------
    !Slightly shorter messages
    !Message('Sent Name: ' & ClipBoard() & ' to the clipboard')
    Message(ClipBoard(),'On Clipboard')

 !End-COMPILE('***Shortest Code***',Shortest)

!==============================================================
 OMIT('***NotShort Code***',Shortest)

AFN         STRING(260),AUTO
FNs         &CSTRING    !(100 * 262 + 1),AUTO
FNsSize     LONG
Cmd         &STRING     !(100 * 262 + 2),AUTO
LenCmd      LONG,AUTO
CX          LONG,AUTO
SendToINI   CSTRING(261)    !Put in same dir as EXE, for Winows use EQUATE('SendToFn.Ini')
NoMsg       BYTE

SortQ   QUEUE,PRE(SortQ)    !Since names can be somewhat random
FN          STRING(260)
FNLow       STRING(260)
        END

    CODE

    !---------------------------
    !I wanted to allow Multiple FNs
    !message('1=' & clip(command('1')) & '||' & 'Cmd ' & clip(command('')) ,'Debug')
    LenCmd=LEN(CLIP(COMMAND('')))
    IF ~LenCmd
        Message('You must Send To file names to this EXE.|Or Drag-n-Drop file names on this EXE.',COMMAND('0'))
        RETURN
    END
    !Command line sent as <short file name>space<short file name>space...
    !XP Sends files with spaces as "filename"space"filename"
    Cmd &= NEW(STRING(LenCmd+1))
    Cmd=COMMAND('')

    LOOP WHILE Cmd
         IF Cmd[1]='"'                  !LFN with spaces get "Quoted" under XP
            CX=INSTRING('"',Cmd,1,2)    !Find the next "
            IF ~CX THEN BREAK.
            AFN=Cmd[2 : CX-1]           !With quotes it will be LFN
            Cmd=LEFT(Cmd[CX+1 : SIZE(Cmd)])
         ELSE
            CX=INSTRING(' ',Cmd,1,2)    !Find the next space
            IF ~CX THEN BREAK.
            AFN=LONGPATH(Cmd[1 : CX-1])
            Cmd=LEFT(Cmd[CX+1 : SIZE(Cmd)])
         END

         !With multple names order is haphazard so sort
         SortQ:FN    = AFN
         SortQ:FNlow = lower(AFN)
         ADD(SortQ,SortQ:FNlow)
         FNsSize += (LEN(CLIP(AFN))+2)
    END

    FNs &= NEW(CSTRING(FNsSize))
    LOOP CX = 1 TO RECORDS(SortQ)
         GET(SortQ,CX)
         IF ~FNs
            FNs=CLIP(SortQ:FN)
         ELSE
            FNs=FNs & '<13,10>' & CLIP(SortQ:FN)
         END
    END
    SetClipboard(FNs)


    !A way to have the message optional
    SendToINI=CLIP(COMMAND('0'))&'.INI'    !Command('0') is EXE file name so this will be in EXE path
    NoMsg=GETINI('Setup','NoMsg',0,SendToINI)
    IF NoMsg AND ~BAND(KEYSTATE(),0100h)
       !User Pushed No Message button previously
       !And does not have Shift Held Down (Hold dow shift when click on SendTo and Msg will show with option to Turn On
    ELSE
        !A Window here could look a lot nicer and have a more obvious checkbox for the "NoMsg" option
        !But the EXE would double in size
        CASE MESSAGE(FNs, |  !clipboard(), |
             'On Clipboard', , |
              'Close|' & CHOOSE(~NoMsg,'No Message','Show Msg'), 1, 0)
        OF 1  ! Name: Close  (Default)
        OF 2  ! Name: No Message
                NoMsg=1-NoMsg
                PUTINI('Setup','NoMsg',NoMsg,SendToINI)
                IF NoMsg THEN
                   Message('To show message again edit ' & SendToINI & '|or shift+click on SendTo FN menu item.')
                END
        END !CASE
    END

!ENd - OMIT('***NotShort Code***',Shortest=True)